﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls;
using Infragistics.Windows;

namespace DataChartZoomBarSync
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private readonly List<RangeItem> _rangeList = new List<RangeItem>();
        private List<TimeItem> _timeValues = new List<TimeItem>();
        public static bool SelectionChanged { get; set; }
        public static int Count { get; set; }
        public static int SelectedIndex { get; set; }
        public static bool DrawHighResReport { get; set; }
      
        public MainWindow()
        {
            InitializeComponent();
          
        }

        private void FilterText_OnSelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            SelectionChanged = true;
        }
        
        private double percentage { get; set; }
        
        private void zoombar1_KeyDown_1(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Right && xmZoombar.Range.Maximum <= xmZoombar.Maximum - 10)
            {
                xmZoombar.Range.Maximum = xmZoombar.Range.Maximum + 10;
                xmZoombar.Range.Minimum = xmZoombar.Range.Minimum + 10;
            }
            if (e.Key == Key.Left && xmZoombar.Range.Minimum >= xmZoombar.Minimum + 10)
            {
                xmZoombar.Range.Maximum = xmZoombar.Range.Maximum - 10;
                xmZoombar.Range.Minimum = xmZoombar.Range.Minimum - 10;
            }
        }

        public bool IsZoombarChanging;

        private void xmDataChart_WindowRectChanged(object sender, Infragistics.RectChangedEventArgs e)
        {
            ContentControl zoombarThumb = Utilities.GetDescendantFromName(xmZoombar, "HorizontalThumbElement") as ContentControl;
            Border zoombarTrackElement = Utilities.GetDescendantFromName(xmZoombar, "HorizontalTrackElement") as Border;
            if (zoombarThumb != null && zoombarTrackElement != null)
            { 
                double maxAllowedRange = 20 / zoombarTrackElement.ActualWidth;

                if (e.NewRect.Width < maxAllowedRange)
                {
                    xmDataChart.WindowRectChanged -= xmDataChart_WindowRectChanged;
                    xmDataChart.WindowRect = e.OldRect;
                    xmDataChart.WindowRectChanged += xmDataChart_WindowRectChanged;
                }
            }
          
        }

   
      
   
     

        private void Grid_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            if ((sender as ContentControl).ActualWidth == 20)
            {
                XamZoombar zoombar = Utilities.GetAncestorFromType(sender as DependencyObject, typeof(XamZoombar), false) as XamZoombar;
                Range range = zoombar.Range;
                double oldScope = range.Maximum - range.Minimum;
                Dispatcher.BeginInvoke(new Action(() =>
                    {
                        Range newRange = zoombar.Range;
                        range.ToString();
                        zoombar.Range = new Range { Minimum = zoombar.Range.Minimum + oldScope, Maximum = zoombar.Range.Minimum + oldScope * 2 };
                    }), System.Windows.Threading.DispatcherPriority.Background, null);
            }
        }

  
    
        
    }

    public class RangeItem
    {
        public RangeItem(TimeRange timerange)
        {
            Timerange = timerange;
        }

        public TimeRange Timerange;

        public override string ToString()
        {
            return Timerange.Min.ToString() + " - " + Timerange.Max.ToString();
        }
    }
    public struct TimeRange
    {
        /// <summary>
        ///     Max time range
        /// </summary>
        public DateTime Max { get; set; }

        /// <summary>
        ///     Min time range
        /// </summary>
        public DateTime Min { get; set; }

        /// <summary>
        ///     Session Id
        /// </summary>
        public Guid Id { get; set; }
    }
    public class TimeItem
    {
        public TimeItem(int seconds, string display)
        {
            Time = seconds;
            Display = display;
        }

        public int Time;
        public string Display;
        public override string ToString()
        {
            return Display;
        }
    }
}
